"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactNative = require("react-native");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const OdpViewManagerCommands = {
  start: 1,
  upload_logs: 2
};
const startOdp = (viewId, key, host) => _reactNative.UIManager.dispatchViewManagerCommand(viewId, OdpViewManagerCommands.start.toString(), [key, host]);
const uploadLogs = viewId => _reactNative.UIManager.dispatchViewManagerCommand(viewId, OdpViewManagerCommands.upload_logs.toString(), []);
const LINKING_ERROR = `The package 'react-native-library' doesn't seem to be linked. Make sure: \n\n` + _reactNative.Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo Go\n';
const OdpComponent = _reactNative.UIManager.getViewManagerConfig('OdpViewManager') != null ? (0, _reactNative.requireNativeComponent)('OdpViewManager') : () => {
  throw new Error(LINKING_ERROR);
};
const OdpModule = (props, parentRef) => {
  const nodeRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(() => {
    console.log('Initializing Event Emitter');
    const eventEmitter = _reactNative.DeviceEventEmitter;
    eventEmitter.addListener('onReady', event => {
      var _props$onOdpEvent$onR, _props$onOdpEvent;
      (_props$onOdpEvent$onR = (_props$onOdpEvent = props.onOdpEvent).onReady) === null || _props$onOdpEvent$onR === void 0 ? void 0 : _props$onOdpEvent$onR.call(_props$onOdpEvent, event);
    });
    eventEmitter.addListener('onKeyValidation', event => {
      var _props$onOdpEvent$onK, _props$onOdpEvent2;
      (_props$onOdpEvent$onK = (_props$onOdpEvent2 = props.onOdpEvent).onKeyValidation) === null || _props$onOdpEvent$onK === void 0 ? void 0 : _props$onOdpEvent$onK.call(_props$onOdpEvent2, event);
    });
    eventEmitter.addListener('onNavigationUpdate', event => {
      var _props$onOdpEvent$onN, _props$onOdpEvent3;
      (_props$onOdpEvent$onN = (_props$onOdpEvent3 = props.onOdpEvent).onNavigationUpdate) === null || _props$onOdpEvent$onN === void 0 ? void 0 : _props$onOdpEvent$onN.call(_props$onOdpEvent3, event);
    });
    eventEmitter.addListener('onFacilityUpdate', event => {
      var _props$onOdpEvent$onF, _props$onOdpEvent4;
      (_props$onOdpEvent$onF = (_props$onOdpEvent4 = props.onOdpEvent).onFacilityUpdate) === null || _props$onOdpEvent$onF === void 0 ? void 0 : _props$onOdpEvent$onF.call(_props$onOdpEvent4, event);
    });
    return () => {
      eventEmitter.removeAllListeners('onReady');
      eventEmitter.removeAllListeners('onKeyValidation');
      eventEmitter.removeAllListeners('onNavigationUpdate');
      eventEmitter.removeAllListeners('onFacilityUpdate');
    };
  }, []);
  (0, _react.useImperativeHandle)(parentRef, () => {
    const nodeHandle = (0, _reactNative.findNodeHandle)(nodeRef.current);
    const listeners = {
      startOdp: (key, host) => {
        startOdp(nodeHandle, key, host);
      },
      uploadLogs: () => {
        uploadLogs(nodeHandle);
      }
    };
    return listeners;
  });

  // @ts-ignore
  return /*#__PURE__*/_react.default.createElement(OdpComponent, {
    ref: nodeRef
  });
};
var _default = /*#__PURE__*/(0, _react.forwardRef)(OdpModule);
exports.default = _default;
//# sourceMappingURL=OdpViewModule.js.map